
#ifndef CONTROLLER_H
#define CONTROLLER_H

#include <tiny2313a.h>

//    
//     Mask[]
#define Port1	RegD
#define MASK1	(1 << 0)	// 0b00000001
#define Port2	RegD
#define MASK2	(1 << 1)	// 0b00000010
#define Port3	RegA
#define MASK3	(1 << 1)	// 0b00000010
#define Port4	RegA
#define MASK4	(1 << 0)	// 0b00000001
#define Port5	RegD
#define MASK5	(1 << 2)	// 0b00000100
#define Port6	RegD
#define MASK6	(1 << 3)	// 0b00001000

#define NumChannel 			6


//#define SwPlus			PIND.0
//#define SwMinus 			PIND.1
#define MAX_EEPROM_ADDR 	127
#define NormSpeed 			0x009C	//   1   0,02 
#define MinSpeed 			0x0618	//    0,2 
#define MaxSpeed 			0x0034  //    0,005 
//#define DSpeed 				0x0030  //     
//#define DelayPress			10		//    


#define MAX_NUMBER_CYCLES	4	//   
#define COMMAND				0
#define GOTO_FIRST			0, 0, 0, 0	//    
#define FIRST				0	//    
#define START_CYCLE			1	//   
#define END_CYCLE			2	//   
#define DO0(a)				COMMAND, START_CYCLE, 0, (a - 1)
#define WHILE0	           	COMMAND, END_CYCLE, 0, 0

#define DO1(a)				COMMAND, START_CYCLE, 1, (a - 1)
#define WHILE1	           	COMMAND, END_CYCLE, 1, 0

#define DO2(a)				COMMAND, START_CYCLE, 2, (a - 1)
#define WHILE2	            COMMAND, END_CYCLE, 2, 0

#define DO3(a)				COMMAND, START_CYCLE, 3, (a - 1)
#define WHILE3	            COMMAND, END_CYCLE, 3, 0

#define WAIT(a)				a
#define CHANNEL(a)			a
#define PWMMASK(a)			a
#define SPEED(a)			a


//unsigned char CountPlus;
//unsigned char CountMinus;

#define CHM0				0x01

#endif
